/**
 * Use apalache to convert quint parse data into TLA+
 *
 * @author Shon Feder, Informal Systems, 2024
 * @author Igor Konnov, konnov.phd, 2024
 *
 * @module
 */
import { ApalacheResult, ServerEndpoint } from './apalache';
/**
 * Get apalache to convert quint parse data into TLA+
 *
 * @param serverEndpoint
 *   a server endpoint
 *
 * @param apalacheVersion
 *  the version of Apalache to use if there is no active server connection
 *
 * @param parseDataJson the flattened, analyzed, parse data, in as a json string
 *
 * @returns right(tlaString) if parsing succeeds, or left(err) explaining the failure
 */
export declare function compileToTlaplus(serverEndpoint: ServerEndpoint, apalacheVersion: string, parseDataJson: string, verbosityLevel: number): Promise<ApalacheResult<string>>;
