/**
 * A checker for multiple updates in inferred effects.
 *
 * @author Gabriela Moreira
 *
 * @module
 */
import { QuintError } from '../quintError';
import { ConcreteEffect, EffectScheme } from './base';
import { EffectVisitor } from './EffectVisitor';
/**
 * Checks effects for multiple updates of the same state variable.
 */
export declare class MultipleUpdatesChecker implements EffectVisitor {
    errors: Map<bigint, QuintError>;
    /**
     * Checks effects for multiple updates of the same state variable.
     *
     * @param effects the effects to look for multiple updates on
     *
     * @returns a map of errors, where the key is the variable id
     */
    checkEffects(effects: EffectScheme[]): Map<bigint, QuintError>;
    exitConcrete(e: ConcreteEffect): void;
}
