/**
 * A visitor for the effects parser
 *
 * @author Gabriela Moreira
 *
 * @module
 */
import { Effect } from './base';
import { EffectListener } from '../generated/EffectListener';
import * as p from '../generated/EffectParser';
/**
 * An ANTLR4 listener that constructs Effect objects out of the abstract
 * syntax tree.
 */
export declare class ToEffectVisitor implements EffectListener {
    effect?: Effect;
    private arrowEffectsStack;
    private entitiesStack;
    private stateVars;
    private idCounter;
    private pushEffect;
    exitReadOnly(): void;
    exitUpdateOnly(): void;
    exitTemporalOnly(): void;
    exitReadAndUpdate(): void;
    exitReadAndTemporal(): void;
    exitPure(): void;
    exitVariableEffect(ctx: p.VariableEffectContext): void;
    enterArrowEffect(): void;
    exitArrowEffect(): void;
    exitEntity(ctx: p.EntityContext): void;
    exitStateVarRef(ctx: p.StateVarRefContext): void;
    private nextId;
}
