/**
 * Updating effects with namespaces for state variables. To be used when a module with variables is instantiated.
 *
 * @author Gabriela Moreira
 *
 * @module
 */
import { Effect } from './base';
/**
 * Adds a namespace, in the format of the namespaces attribute in LookupDefinition, to all state variables in an effect.
 *
 * @param effect - The effect to add the namespaces to
 * @param namespaces - The namespaces to add
 *
 * @return The effect with namespaces added to all state variables
 */
export declare function addNamespaces(effect: Effect, namespaces: string[]): Effect;
