/**
 * Pretty printing for Effects.
 *
 * @author Gabriela Moreira
 *
 * @module
 */
import { Effect, EffectComponent, EffectScheme, Entity } from './base';
import { Substitutions } from './substitutions';
/**
 * Formats the string representation of  an effect
 *
 * @param e the effect to be formatted
 *
 * @returns a string with the pretty printed effect
 */
export declare function effectToString(e: Effect): string;
/**
 * Formats the string representation of an effect scheme
 *
 * @param e the effect scheme to be formatted
 *
 * @returns a string with the formatted effect scheme
 */
export declare function effectSchemeToString(e: EffectScheme): string;
export declare function effectComponentToString(c: EffectComponent): string;
/**
 * Formats the string representation of effect entities
 *
 * @param v the Entity to be formatted
 *
 * @returns a string with the pretty printed entity
 */
export declare function entityToString(v: Entity): string;
/**
 * Formats the string representation of substitutions
 *
 * @param s the Substitution to be formatted
 *
 * @returns a string with the pretty printed substitution
 */
export declare function substitutionsToString(subs: Substitutions): string;
