/**
 * A generator of unique ids.
 */
export interface IdGenerator {
    /**
     * Generate the next identifier, which is different from the identifiers
     * that have been generated by this instance so far.
     */
    nextId(): bigint;
}
/**
 * Introduce a new id generator.
 */
export declare const newIdGenerator: (initialId?: bigint) => {
    _lastId: bigint;
    nextId(): bigint;
};
/**
 * An id generator that always returns 0n, instead of a unique id.
 */
export declare const zerog: {
    nextId: () => bigint;
};
