import { IdGenerator } from '../idGenerator';
import { SourceMap } from '../parsing/quintParserFrontend';
import { AnalysisOutput } from '../quintAnalyzer';
import { QuintDef } from './quintIr';
/**
 * Given a QuintDef, generates fresh IDs for all its components using the
 * provided IdGenerator. Returns a new QuintDef with the updated IDs. Also extends
 * the provided source map and analysis output, such that they contain the respective
 * entries under both their old and new IDs.
 *
 * @param def - The QuintDef to update with fresh IDs.
 * @param idGenerator - The IdGenerator to use for generating fresh IDs.
 * @param sourceMap - A source map to be updated with sources for the new ids
 *   (should contain entries for the existing ids)
 * @param analysisOutput - An analysis output to be updated with analysis for the new ids
 *   (should contain entries for the existing ids)
 * @returns A new QuintDef with fresh IDs.
 */
export declare function generateFreshIds(def: QuintDef, idGenerator: IdGenerator, sourceMap: SourceMap, analysisOutput: AnalysisOutput): QuintDef;
