import { QuintDef } from './quintIr';
/**
 * Adds a namespace to a QuintDef and the names inside it, preserving a set of names.
 *
 * @param def - The QuintDef to add the namespace to.
 * @param namespace - The namespace to add.
 * @param namesToPreserve - A set of names that should not receive the namespace (e.g. builtin names).
 * @returns A new QuintDef with the namespace added to its name and all names inside it.
 */
export declare function addNamespaceToDefinition(def: QuintDef, namespace: string, namesToPreserve: Set<string>): QuintDef;
