/**
 * Error messages for Quint imports, instances and exports resolution.
 *
 * @author Gabriela Moreira
 *
 * @module
 */
import { QuintError } from '../quintError';
import { QuintExport, QuintImport, QuintInstance, QuintLambdaParameter } from '../ir/quintIr';
export declare function selfReferenceError(def: QuintImport | QuintInstance | QuintExport): QuintError;
export declare function moduleNotFoundError(def: QuintImport | QuintInstance | QuintExport): QuintError;
export declare function nameNotFoundError(def: QuintImport | QuintExport): QuintError;
export declare function paramNotFoundError(def: QuintInstance, param: QuintLambdaParameter): QuintError;
export declare function paramIsNotAConstantError(def: QuintInstance, param: QuintLambdaParameter): QuintError;
