/// <reference types="node" />
/// <reference types="node" />
import * as readline from 'readline';
import { Readable, Writable } from 'stream';
import { QuintModule } from './ir/quintIr';
import { SourceMap } from './parsing/quintParserFrontend';
import { IdGenerator } from './idGenerator';
import { AnalysisOutput } from './quintAnalyzer';
export declare const settings: {
    prompt: string;
    continuePrompt: string;
};
/**
 * A data structure that holds the state of the compilation process.
 */
export interface CompilationState {
    idGen: IdGenerator;
    sourceCode: Map<string, string>;
    modules: QuintModule[];
    mainName?: string;
    sourceMap: SourceMap;
    analysisOutput: AnalysisOutput;
}
export declare function newCompilationState(): CompilationState;
export interface ReplOptions {
    preloadFilename?: string;
    importModule?: string;
    verbosity: number;
}
export declare function quintRepl(input: Readable, output: Writable, options?: ReplOptions, exit?: () => void): readline.Interface;
