"use strict";
/* ----------------------------------------------------------------------------------
 * Copyright 2024 Informal Systems
 * Licensed under the Apache License, Version 2.0.
 * See LICENSE in the project root for license information.
 * --------------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Trace = void 0;
/**
 * Trace of states representing a single execution path
 *
 * @author Gabriela Moreira
 *
 * @module
 */
const immutable_1 = require("immutable");
class Trace {
    constructor() {
        this.states = (0, immutable_1.List)();
    }
    get() {
        return this.states.toArray();
    }
    reset(values = []) {
        this.states = (0, immutable_1.List)(values);
    }
    extend(state) {
        this.states = this.states.push(state);
    }
}
exports.Trace = Trace;
//# sourceMappingURL=trace.js.map