import { QuintType, Row } from '../ir/quintTypes';
import { Either } from '@sweet-monads/either';
/**
 * Parses a type represented as a string into an Type
 *
 * @param typeString the string to be parsed
 *
 * @returns the parsed type when the string is a valid type.
 *          Otherwise, a list of parsing errors.
 */
export declare function parseType(typeString: string): Either<any[], QuintType>;
export declare function parseTypeOrThrow(type: string): QuintType;
export declare function parseRowOrThrow(row: string): Row;
