import { QuintType } from '../ir/quintTypes';
import { Constraint, TypeScheme } from './base';
import { Substitutions } from './substitutions';
/**
 * Formats the string representation of a constraint
 *
 * @param c the Constraint to be formatted
 *
 * @returns a string with the formatted constraint
 */
export declare function constraintToString(c: Constraint): string;
/**
 * Formats the string representation of a type scheme
 *
 * @param t the type scheme to be formatted
 *
 * @returns a string with the formatted type scheme
 */
export declare function typeSchemeToString(t: TypeScheme): string;
export declare function canonicalTypeScheme(t: TypeScheme): [string[], QuintType];
/**
 * Formats the string representation of substitutions
 *
 * @param subs the Substitution to be formatted
 *
 * @returns a string with the pretty printed substitution
 */
export declare function substitutionsToString(subs: Substitutions): string;
