/**
 * Resolution of type application
 *
 * @author Shon Feder
 *
 * @module
 */
import { ErrorTree } from '../errorTree';
import { IRTransformer } from '../ir/IRTransformer';
import { QuintDeclaration } from '../ir/quintIr';
import { QuintType } from '../ir/quintTypes';
import { LookupTable } from '../names/base';
/** Resolves all type applications in an IR object */
export declare class TypeApplicationResolver implements IRTransformer {
    private errors;
    private freshVarGenerator;
    private table;
    constructor(table: LookupTable);
    resolveTypeApplications(decls: QuintDeclaration[]): [Map<bigint, ErrorTree>, QuintDeclaration[]];
    exitType(t: QuintType): QuintType;
    private resolveTypeApplicationsForType;
    private resolveTypeApp;
    private freshTypeFromDef;
}
