export declare const verbosity: {
    /**
     * The default verbosity level.
     */
    defaultLevel: number;
    /**
     * The maximal verbosity level.
     */
    maxVerbosity: number;
    /**
     * Shall REPL show the prompts like '>>> ' and '... '?
     */
    hasReplPrompt: (level: number) => boolean;
    /**
     * Shall REPL show the banner?
     */
    hasReplBanners: (level: number) => boolean;
    /**
     * Shall the tool output the execution results.
     */
    hasResults: (level: number) => boolean;
    /**
     * Shall the tool output details about failing tests.
     */
    hasTestDetails: (level: number) => boolean;
    /**
     * Shall the tool write hints, e.g., how to change settings.
     */
    hasHints: (level: number) => boolean;
    /**
     * Shall the tool output states, e.g., in counterexamples.
     */
    hasStateOutput: (level: number) => boolean;
    /**
     * Shall the tool output witnesses counts.
     */
    hasWitnessesOutput: (level: number) => boolean;
    /**
     * Shall the tool track and output actions that were executed.
     */
    hasActionTracking: (level: number) => boolean;
    /**
     * Shall the tool track and output user-defined operators (not only actions).
     */
    hasUserOpTracking: (level: number) => boolean;
    /**
     * Shall the tool output debug info.
     */
    hasDebugInfo: (level: number) => boolean;
};
