"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const mocha_1 = require("mocha");
const textUtils_1 = require("./textUtils");
const builtin_1 = require("../src/builtin");
const idGenerator_1 = require("../src/idGenerator");
// Use a global id generator, limited to this test suite.
const idGen = (0, idGenerator_1.newIdGenerator)();
(0, mocha_1.describe)('builtInDocs', () => {
    (0, mocha_1.it)('has documentation for builtin definitions', () => {
        const result = (0, builtin_1.builtinDocs)(idGen);
        chai_1.assert.deepEqual(result.get('Bool'), {
            name: 'Bool',
            signature: 'pure val Bool: Set[bool]',
            documentation: (0, textUtils_1.dedent)(`The set of all booleans
          |
          |That is, Set(false, true)`),
        });
    });
});
//# sourceMappingURL=builtin.test.js.map