"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_1 = require("mocha");
const chai_1 = require("chai");
const printing_1 = require("../../src/effects/printing");
const parser_1 = require("../../src/effects/parser");
const namespaces_1 = require("../../src/effects/namespaces");
(0, mocha_1.describe)('addNamespace', () => {
    (0, mocha_1.it)('adds namespaces to state variable names', () => {
        const namespaces = ['Second', 'First'];
        const effect = (0, parser_1.parseEffectOrThrow)("Read['x'] & Update[e0, 'y']");
        const result = (0, namespaces_1.addNamespaces)(effect, namespaces);
        chai_1.assert.deepEqual((0, printing_1.effectToString)(result), "Read['First::Second::x'] & Update[e0, 'First::Second::y']");
    });
});
//# sourceMappingURL=namespaces.test.js.map