"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_1 = require("mocha");
const chai_1 = require("chai");
const errorTree_1 = require("../src/errorTree");
(0, mocha_1.describe)('errorTreeToString', () => {
    (0, mocha_1.it)('converts errorTree to multiline string', () => {
        const errorTree = {
            location: 'General location',
            children: [
                {
                    location: 'Specific location 1',
                    message: 'Message for 1',
                    children: [],
                },
                {
                    location: 'Specific location 2',
                    message: 'Message for 2',
                    children: [],
                },
            ],
        };
        const expectedError = `Message for 1
Specific location 1
and
Message for 2
Specific location 2
General location
`;
        chai_1.assert.deepEqual((0, errorTree_1.errorTreeToString)(errorTree), expectedError);
    });
});
//# sourceMappingURL=errorTree.test.js.map